import React, { useEffect, useState } from 'react';
// import ToggleIcon from '@material-ui/icons/PlayCircleFilled';
// import  ToggleIcon  from 'caret-square-right-solid.svg';
import DataTypes from './dataTypes/DataTypes';
import { getTypes } from './dataTypes/getTypes';
interface DetailState{
  data?:{[key:string]:any}|undefined,
  onEdit:(newValue:any,key:string|number)=>void,
  onDelete:(key:number|string)=>void,
}
const DataView:React.FC<DetailState> = ({ data, onDelete, onEdit }:DetailState) => {
  const [col, setCol] = useState(false);
  const [keys, setKeys] = useState<string[]>([]);
  const [currentData, setCurrentData] = useState<DetailState["data"]>({});
  useEffect(() => {
    let newkeys:string[]|undefined=Object.getOwnPropertyNames(data);
    setKeys(newkeys);
    setCurrentData(data);
  }, [data]);

  const toggleJsonView = ():void => {
    setCol(!col);
  };

  const renderData = () => {
    if (col)
      return (
        <div className='p5'>
          <span className='colorGray'>
            <span>{'{'}</span>
            {currentData?Object.keys(currentData).length:""} items<span>{'}'}</span>
          </span>
        </div>
      );
    return keys.map((k) => {
      return (
        <div key={k}>
          <DataTypes
            key={k}
            dataType={currentData?getTypes(currentData[k]):""}
            dataValue={currentData?currentData[k]:""}
            dataKey={k}
            onEdit={onEdit}
            onDelete={onDelete}
          />
        </div>
      );
    });
  };
  return (
    <div className='JsonTree'>
      <div>
      {/* <img src={ToggleIcon} alt="logo" onClick={toggleJsonView}/> */}
        <div onClick={toggleJsonView} className='mainCollapseIcon'>
        <svg aria-hidden="true" focusable="false" data-prefix="fas" data-icon="caret-square-right" className="svg-inline--fa fa-caret-square-right fa-w-14" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path fill="currentColor" d="M48 32h352c26.51 0 48 21.49 48 48v352c0 26.51-21.49 48-48 48H48c-26.51 0-48-21.49-48-48V80c0-26.51 21.49-48 48-48zm140.485 355.515l123.029-123.029c4.686-4.686 4.686-12.284 0-16.971l-123.029-123.03c-7.56-7.56-20.485-2.206-20.485 8.485v246.059c0 10.691 12.926 16.045 20.485 8.486z"></path></svg>
        </div>
        {/* <ToggleIcon  /> */}
        "root" :<span className='boldStyle pl5'>{'{'}</span>
        {renderData()}
        <div className='boldStyle '>{'}'}</div>
      </div>
    </div>
  );
};

export default DataView;
